//
//  ItemRecord.swift
//  MemriDatabase
//
//  Created by T Brennan on 21/12/20.
//

import Foundation
import GRDB

struct NavigationStack: FetchableRecord, PersistableRecord, Equatable, Identifiable, Codable {
    static var databaseTableName: String { "navigationState" }
    
    var sessionID: StringUUID = StringUUID()
    var state: [ViewContextHolder] = []
    
    var id: StringUUID {
        sessionID
    }
    
    static func == (lhs: NavigationStack, rhs: NavigationStack) -> Bool {
        lhs.sessionID == rhs.sessionID && lhs.state == rhs.state
    }
    
    enum Columns: String, ColumnExpression {
        case sessionID, state
    }
}
