//
// CVU_Toggle.swift
// Copyright © 2020 memri. All rights reserved.

import SwiftUI

/// A CVU element for displaying a toggle
/// - Set the `value` property to an expression representing the boolean item property to be toggled
struct CVU_Toggle: View {
    var nodeResolver: CVUUINodeResolver

    var binding: Binding<Bool> {
        nodeResolver.propertyResolver.binding(for: "value", defaultValue: false) ?? .constant(false)
    }

    var body: some View {
        Toggle(isOn: binding) { EmptyView() }
            .labelsHidden()
    }
}
