//
//  ActivityIndicatorView.swift
//  MemriDatabase
//
//  Created by T Brennan on 6/12/20.
//

import SwiftUI

/// A view used to represent activity of unknown duration/progress (the spinning wheel)
struct ActivityIndicatorView: UIViewRepresentable {
    var isAnimating: Bool = true
    var style: UIActivityIndicatorView.Style = .medium
    var color: Color? = nil

    func makeUIView(context _: Context)
        -> UIActivityIndicatorView
    {
        let view = UIActivityIndicatorView(style: style)
        color.map { view.color = UIColor($0) }
        return view
    }

    func updateUIView(
        _ uiView: UIActivityIndicatorView,
        context _: Context
    ) {
        isAnimating ? uiView.startAnimating() : uiView.stopAnimating()
    }
}

struct ActivityIndicatorView_Previews: PreviewProvider {
    static var previews: some View {
        ActivityIndicatorView()
    }
}
