//
//  ToolbarWrapperView.swift
//  MemriDatabase
//
//  Created by T Brennan on 14/12/20.
//

import Foundation
import UIKit

class ToolbarWrapperView: UIView {
    var toolbarView: UIView

    init(toolbarView: UIView) {
        self.toolbarView = toolbarView
        super.init(frame: .zero)

        toolbarView.setContentHuggingPriority(.defaultLow, for: .horizontal)
        toolbarView.setContentCompressionResistancePriority(.defaultLow, for: .horizontal)

        addSubview(toolbarView)
        translatesAutoresizingMaskIntoConstraints = false
        toolbarView.translatesAutoresizingMaskIntoConstraints = false
        NSLayoutConstraint.activate([
            toolbarView.topAnchor.constraint(equalTo: safeAreaLayoutGuide.topAnchor),
            toolbarView.leadingAnchor.constraint(equalTo: safeAreaLayoutGuide.leadingAnchor),
            toolbarView.trailingAnchor.constraint(equalTo: safeAreaLayoutGuide.trailingAnchor),
            toolbarView.bottomAnchor.constraint(equalTo: safeAreaLayoutGuide.bottomAnchor),
        ])
    }

    @available(*, unavailable)
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }

    override var intrinsicContentSize: CGSize {
        CGSize(
            width: UIView.noIntrinsicMetric,
            height: toolbarView.intrinsicContentSize.height + safeAreaInsets.bottom
        )
    }

    override func safeAreaInsetsDidChange() {
        super.safeAreaInsetsDidChange()
        invalidateIntrinsicContentSize()
    }
}
