//
//  NavigationHolder.swift
//  Memri
//
//  Created by T Brennan on 23/1/21.
//

import SwiftUI

struct NavigationHolder: UIViewControllerRepresentable {
    var controller: MemriUINavigationController
    func makeUIViewController(context: Context) -> MemriUINavigationController {
        return controller
    }
    
    func updateUIViewController(_ navController: MemriUINavigationController, context: Context) {

    }
}

class MemriUINavigationController: UINavigationController {
    override func viewDidLoad() {
        super.viewDidLoad()
        super.isNavigationBarHidden = true
    }
    
    override var isNavigationBarHidden: Bool {
        get { super.isNavigationBarHidden } set { super.isNavigationBarHidden = true }
    }
    
    override func setNavigationBarHidden(_ hidden: Bool, animated: Bool) {
        super.setNavigationBarHidden(true, animated: false)
    }
}
