//
//  MainView.swift
//  memri
//
//  Created by T Brennan on 7/12/20.
//  Copyright © 2020 memri. All rights reserved.
//

import Foundation
import SwiftUI

/// This is the view used in each scene to display the appropriate state
/// This depends on whether the app has been setup, and if the user is authenticated.
struct MainView: View {
    @ObservedObject var appController: AppController = AppController.shared
    @ObservedObject var sceneController: SceneController
    
    var body: some View {
        switch appController.state {
        case .setup:
            SetupScreenView()
        case .authentication:
            AuthenticationScreen()
        case .authenticated:
            SceneView(sceneController: sceneController)
        }
    }
}
